module Bob
  module Compiler
    class Message
      attr_reader :message, :line

      def initialize(message, node_or_line_number)
        @message = message
        @line    = extract_line_number(node_or_line_number)
      end

      def <=>(other)
        line <=> other.line
      end

      private
        def extract_line_number(node_or_line_number)
          node_or_line_number.line rescue node_or_line_number
        end
    end
  end
end
